/**
  Create a new process, using all default parameters
  Orion Sky Lawlor, olawlor@acm.org, 2006/1/23 (Public Domain)
*/
#include <stdio.h>
#include <windows.h>

enum {runTimes=20, delayLen=1*1000*1000};
int total=0;
void *run(void *ptr) {
        int threadNo=*(int *)ptr;
        for (int n=0;n<runTimes;n++) {
                for (int i=0;i<delayLen;i++) {}
                printf("%c: (it %d)  (total %d)\n",'A'+threadNo,n,total);
                total++;
        }
        return 0;
}

int main(int argc,char *argv[]) {
        int count=0;
        if (argc<=1) { /* create a second process */
		printf("We are the original--creating a second process.\n");
                STARTUPINFO si={0};
                PROCESS_INFORMATION pi;
                CreateProcess(
                  0, /* program name */
                  "code.exe a b c", /* command line */
                  0,0,false,
		  CREATE_NEW_PROCESS_GROUP, /* separates his execution from ours */
		  0,0, /* optional stuff */
                  &si,&pi /* startup information, process information */
                );
		printf("Original now running.\n");
                count=0;
                run(&count);
        } else { /* we *are* the second process */
		printf("I'm the second process.  Hi!  Lemme run for ya...\n");
                count=1;
                run(&count);
        }
        return 0;
}

